/* **********************************************************
 * Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
 * **********************************************************/

#ifndef _CPUID_INFO_H
#define _CPUID_INFO_H

#define INCLUDE_ALLOW_USERLEVEL
#define INCLUDE_ALLOW_MODULE
#define INCLUDE_ALLOW_VMCORE
#define INCLUDE_ALLOW_VMKERNEL
#include "includeCheck.h"


typedef struct CPUIDRegs {
   uint32 eax, ebx, ecx, edx;
} CPUIDRegs;

/*
 * Results of calling cpuid(eaxArg) on all logical processors. 
 */
typedef struct CPUIDResult {
   uint32 numLogicalCPUs;
   uint32 eaxArg;
   CPUIDRegs regs[0];
} CPUIDResult;


typedef struct CPUIDSummary {
   struct {
      int numEntries;
      char name[16];      // 4 extra bytes to null terminate
   } id0;
   struct {
      uint32 version;
      uint32 ebx;
      uint32 ecxFeatures;
      uint32 edxFeatures;
   } id1;
   struct {
      uint32 numEntries;
      uint32 ebx;
      uint32 ecx;
      uint32 edx;
   } id80;
   struct {
      uint32 eax;
      uint32 ebx;
      uint32 ecx;
      uint32 edxFeatures;
   } id81;
   struct {
      uint32 eax;
      uint32 ebx;
      uint32 ecx;
      uint32 edx;
   } id88;
} CPUIDSummary;

#endif
